;Title: MySQL Interface for mIRC
;Version: 1.3
;Author: MonoTeK
;Date: 2004/10/04
;Email: monotek@psiblade.net

alias mysql_config {
  var %mysql.host = $$input(MySQL Server Host/IP,eo,MySQL Configuration,localhost)
  var %mysql.port = $$input(MySQL Server Port,eo,MySQL Configuration,3306)
  var %mysql.username = $$input(MySQL Username,eo,MySQL Configuration)
  var %mysql.password = $input(MySQL Password (optional),po,MySQL Configuration)
  var %mysql.database = $$input(Default MySQL Database,eo,MySQL Configuration)
  var %mysql.htmlout = $$input(Enable HTML output for query results?,y,MySQL Configuration)
  if (%mysql.htmlout) {
    var %mysql.htmlout.file = $input(Filename for HTML output,eo,MySQL Configuration,$scriptdir $+ \sql_out.html)
    var %mysql.htmlout.run = $$input(Display HTML file when finished?,y,MySQL Configuration)
  }
  var %mysql.cwindow = $$input(Enable output to custom window @MySQL?,y,MySQL Configuration)
  var %mysql.verbose = $$input(Enable verbose output?,y,MySQL Configuration)
  var %mysql.debug = $$input(Enable debug output?,y,MySQL Configuration)
  writeini mysql.conf general host %mysql.host
  writeini mysql.conf general port %mysql.port
  writeini mysql.conf general username %mysql.username
  if (%mysql.password != $null) writeini mysql.conf general password $encode(%mysql.password,m)
  else {
    remini mysql.conf general password
    var %mysql.pchk = $$input(Ask for password on connect?,y,MySQL Configuration)
    if (%mysql.pchk) writeini mysql.conf general pchk $true
    else writeini mysql.conf general pchk $false
  }
  writeini mysql.conf general database %mysql.database
  writeini mysql.conf general htmlout %mysql.htmlout
  if (%mysql.htmlout.file != $null) writeini mysql.conf general htmlout.file %mysql.htmlout.file
  if (%mysql.htmlout.run != $null) writeini mysql.conf general htmlout.run %mysql.htmlout.run
  writeini mysql.conf general cwindow %mysql.cwindow
  writeini mysql.conf general verbose %mysql.verbose
  writeini mysql.conf general debug %mysql.debug
}

;### These are now stored in mysql.conf
alias mysql_htmlout return $iif($readini(mysql.conf,general,htmlout) != $null,$readini(mysql.conf,general,htmlout),$false)
alias mysql_htmlout.file return $iif($readini(mysql.conf,general,htmlout.file),$readini(mysql.conf,general,htmlout.file),sql_out.html)
alias mysql_htmlout.run return $iif($readini(mysql.conf,general,htmlout.run) != $null,$readini(mysql.conf,general,htmlout.run),$true)
alias mysql_cwindow return $iif($readini(mysql.conf,general,cwindow) != $null,$readini(mysql.conf,general,cwindow),$false)
alias mysql_verbose return $iif($readini(mysql.conf,general,verbose) != $null,$readini(mysql.conf,general,verbose),$true)
alias mysql_debug return $iif($readini(mysql.conf,general,debug) != $null,$readini(mysql.conf,general,debug),$false)
;###

alias mysql_echo {
  if ($mysql_cwindow) {
    if (!$window(@MySQL)) window -ezk0 @MySQL
    echo -t @MySQL $1-
  }
  elseif ($strip($1) == ERROR) { echo -ta (MySQL) $1- }
  if ($dialog(mysql_gui)) { did -a mysql_gui 20 $crlf $+ $strip($1-) }
}
alias mysql_vecho {
  if ($mysql_verbose) {
    if ($mysql_cwindow) {
      if (!$window(@MySQL)) window -ezk0 @MySQL
      echo -t @MySQL $1-
    }
    if ($dialog(mysql_gui)) { did -a mysql_gui 20 $crlf $+ $strip($1-) }
  }
}
alias mysql_decho {
  if ($mysql_debug) {
    if ($mysql_cwindow) {
      if (!$window(@MySQL)) window -ezk0 @MySQL
      echo @MySQL $1-
    }
  }
}

alias mysql_connect {
  if ($sock(mysql)) mysql_disconnect
  unset %mysql*
  hfree -w mysql*
  if ($1 != $null) set %mysql_client.host $1
  else set %mysql_client.host $readini(mysql.conf,General,host)
  if ($2 != $null) set %mysql_client.port $2
  else set %mysql_client.port $readini(mysql.conf,General,port)
  if ($3 != $null) set %mysql_client.database $3
  else set %mysql_client.database $readini(mysql.conf,General,database)
  if ($4 != $null) set %mysql_client.username $4
  else set %mysql_client.username $readini(mysql.conf,General,username)
  if ($5 != $null) set %mysql_client.password $encode($5,m)
  elseif ($4 == $null) set %mysql_client.password $readini(mysql.conf,General,password)
  if (%mysql_client.host == $null) || (%mysql_client.port == $null) || (%mysql_client.username == $null) || (%mysql_client.database == $null) {
    mysql_echo 4ERROR >> No configuration settings found. Please run '/mysql_config' first.
    halt
  }
  if ((%mysql_client.password == $null) && ($readini(mysql.conf,general,pchk))) {
    set %mysql_pass $encode($input(Password for %mysql_client.username,6,MySQL Login),m)
    if ($dialog(mysql_gui)) dialog -v mysql_gui
  }
  else set %mysql_pass %mysql_client.password
  mysql_echo  $+ $color(info) MySQL>> Connecting to ' $+ %mysql_client.host $+ ' on port ' $+ %mysql_client.port $+ '
  sockopen mysql %mysql_client.host %mysql_client.port
}
alias mysql_disconnect {
  if ($sock(mysql)) {
    mysql_echo  $+ $color(info) MySQL>> Closed Connection
    mysql_echo  $+ $color(info) $+ -
    sockclose mysql
    unset %mysql*
  }
  else { mysql_echo  $+ $color(info) MySQL >> MySQL_Disconnect: Not connected to a server. }
}
alias mysql_use {
  if ($mysql_status) {
    mysql_vecho  $+ $color(mode) MySQL>> Changing to database ' $+ $1 $+ '
    set %mysql_use_data $2-
    mysql.send  $+ $1
  }
  else {
    mysql_echo 4ERROR >> MySQL_Use: Must be connected to a server.
  }
}
alias mysql_query {
  if ($mysql_status) {
    var %badtok = select insert update create delete drop show load alter rename error describe start savepoint lock set rollback truncate replace row columns result
    if ($istok(%badtok,$1,32)) {
      mysql_echo 4ERROR >> MySQL_Query: Restricted Query Name ' $+ $1 $+ '
      return
    }
    else {
      if (%mysql_queryname != $null) { mysql_echo 4MySQL_Query: A query ( $+ %mysql_queryname $+ ) is already in progress. }
      else {
        hfree -w mysql_*
        mysql_vecho  $+ $color(mode) MySQL>>  $+ $color(normal) $+ $2-
        set %mysql_queryname $1
        set %mysql_querycid $cid
        mysql.send  $+ $2-
      }
    }
  }
  else {
    mysql_echo 4ERROR >> MySQL_Query: Must be connected to a server.
  }
}
alias mysql_param {
  ;$1 = query name
  ;$2 = parameter name
  ;$3- = parameter data
  mysql_decho param: $1-
  if ($3 == $null) { mysql_echo 4ERROR >> MySQL_Param: Invalid Parameters }
  var %badtok = select insert update create delete drop show load alter rename error describe start savepoint lock set rollback truncate replace row columns result
  if ($istok(%badtok,$1,32)) {
    mysql_echo 4ERROR >> MySQL_Param: Restricted Query Name ' $+ $1 $+ '
    return
  }
  else { hadd -m mysql_ $+ $1 $+ . $+ params $2 $3- }
}
alias mysql_getparam {
  if ($2 == $null) {
    mysql_echo 4ERROR >> MySQL_GetParam: No parameter name specified
    return
  }
  elseif ($1 == $null) {
    mysql_echo 4ERROR >> MySQL_GetParam: No query name specified
    return
  }
  var %badtok = select insert update create delete drop show load alter rename error describe start savepoint lock set rollback truncate replace row columns result
  if ($istok(%badtok,$1,32)) {
    mysql_echo 4ERROR >> MySQL_GetParam: Restricted Query Name ' $+ $1 $+ '
    return
  }
  return $hget(mysql_ $+ $1 $+ . $+ params,$2)
}
alias mysql_getfield {
  if ($1 isnum) && ($1 > 0) var %col = $hget(mysql.columns,col. $+ $1)
  elseif ($1 isnum) && ($1 <= 0) {
    mysql_echo 4ERROR >> MySQL_GetField: Invalid Parameters (Col: $1 $+ )
    return
  }
  else var %col = $1
  if ($2 isnum) && ($2 > 0) return $hget(mysql.row. $+ $2, %col)
  else mysql_echo 4ERROR >> MySQL_GetField: Invalid Parameters (Row: $2 $+ )
}
alias mysql_getcol {
  if ($1 isnum) && ($1 <= 0) return $mysql_colcount
  elseif ($1 isnum) return $hget(mysql.columns,col. $+ $1)
  else return $hget(mysql.columns,$1)
}
alias mysql_colcount {
  var %mysql.colcount = 0
  while ($hget(mysql.columns,col. $+ $calc(%mysql.colcount + 1)) != $null) { inc %mysql.colcount }
  return %mysql.colcount
}
alias mysql_rowcount {
  var %mysql.rowcount = 0
  while ($hget(mysql.row. $+ $calc(%mysql.rowcount + 1)) != $null) { inc %mysql.rowcount }
  return %mysql.rowcount
}
alias mysql_rows_affected return $hget(mysql.result,affected)
alias mysql_open mysql_connect $1-
alias mysql_close mysql_disconnect
alias mysql_clear hfree -w mysql*
alias mysql_error return %mysql.error
alias mysql_status {
  if ($sock(mysql).mark == OK) return 1
  else return 0
}
alias mysql_escape return $replace($1-,\,\\,',\',",\")

on *:sockopen:mysql:{
  if ($sockerr > 0) { mysql_echo 4ERROR >> Connection Failed (Error: $sockerr $+ ) }
  else { mysql_echo  $+ $color(info) MySQL>> Connected to server, logging in... }
}
on *:sockclose:mysql:{
  if (%mysql_query != $null) {
    mysql_echo  $+ $color(info) MySQL>> Connection lost during query, reconnecting... (Rerun query)
    mysql_connect
  }
  else {
    mysql_echo  $+ $color(info) MySQL>> Connection lost
    unset %mysql*
  }
}
on *:sockread:mysql:{
  ;# Check for any errors that may have occured during the last read.
  if ($sockerr > 0) { 
    mysql_echo 4ERROR >> Failed to read from the server. (Error: $sockerr $+ )
    return
  }

  ;# If we haven't read the header information yet, do so, otherwise go and get the data.
  if (%mysql.packetlen == $null) mysql.getheader
  else mysql.getdata
}

alias -l mysql.getheader {
  ;/*
  ;  Here's where we read the first 3 bytes of the packet to determine the packet length.
  ;  After we get the packet length we'll check to see if the rest of this packet is already in the receive buffer.
  ;  If it is, send it to the mysql.getdata function, otherwise just let the script automatically do another sockread.
  ;*/
  bunset &mysql.header &mysql.data &mysql.data_in
  if ($isfile(mysql.dat)) .remove mysql.dat
  if ($sock(mysql).rq >= 3) {
    if ($isfile(mysql.hdat)) {
      bread mysql.hdat 0 3 &mysql.htemp
      if ($bvar(&mysql.htemp,0) < 3) var %hbl = $calc(3 - $bvar(&mysql.htemp,0))
      else var %hbl = 3
    }
    else var %hbl = 3
    sockread %hbl &mysql.header
    if ($bvar(&mysql.htemp,0)) {
      bcopy &mysql.htemp $calc($bvar(&mysql.htemp,0) + 1) &mysql.header 1 -1
      bcopy &mysql.header 1 &mysql.htemp 1 -1
      if ($isfile(mysql.hdat)) .remove mysql.hdat
    }
    set %mysql.packetlen $calc($mysql.calcpl(&mysql.header) + 1)
    set %mysql.bl %mysql.packetlen
    mysql_decho GETHEADER> Header: $bvar(&mysql.header,1) $bvar(&mysql.header,2) $bvar(&mysql.header,3) PacketLen: %mysql.packetlen
    if ($sock(mysql).rq > 0) mysql.getdata
  }
  else {
    mysql_decho GetHeader: Header is incomplete, waiting for next tcp packet
    sockread 3 &mysql.header
    bwrite mysql.hdat -1 -1 &mysql.header
  }
}
alias -l mysql.getdata {
  ;/*
  ;  This basically tries to read the rest of the packet until it has been completely received.
  ;  When the entire packet is read, it will send it off to be parsed by mysql.proc
  ;*/
  sockread %mysql.bl &mysql.data
  if ($isfile(mysql.dat)) {
    bwrite mysql.dat -1 -1 &mysql.data
  }
  mysql_decho GETDATA> Sockbr: $sockbr BL: %mysql.bl
  if ($sockbr == %mysql.bl) mysql.sqlproc
  else {
    set %mysql.bl $calc(%mysql.bl - $sockbr)
    bwrite mysql.dat -1 -1 &mysql.data
  }
}

alias -l mysql.sqlproc {
  ;/*
  ;  This function is responsible for parsing the data returned by the server into something usable in mirc.
  ;  After this function is finished, it will send out a signal named 'mysql' so any scripts listening for that
  ;  signal can then decide what to do with the information.
  ;*/
  if ($isfile(mysql.dat)) {
    bread mysql.dat 0 %mysql.packetlen &mysql.data
    .remove mysql.dat
  }
  unset %mysql.*
  var %bvl = $bvar(&mysql.data,0)
  var %cb = 1
  if ($mysql_debug) {
    while (%cb <= %bvl) {
      if ($bvar(&mysql.data,%cb) == 32) {
        ;# This is a cheap way to add a space to the output variable =)
        ;# We basically read the value after the space(s) and write it with the space included.
        ;# Due to the limitations of mIRC, more than one space will be trimmed down to a single space.
        while ($bvar(&mysql.data,%cb) != 32) inc %cb
        var %op = %op $chr($bvar(&mysql.data,%cb))
        inc %cb 1
      }
      elseif ($bvar(&mysql.data,%cb) == 0) {
        ;# If we run into a NULL value, replace it with a 0 in the output.
        var %op = %op $+ 0
        inc %cb 1
      }
      else {
        var %op = %op $+ $chr($bvar(&mysql.data,%cb))
        inc %cb 1
      }
    }
    var %op = $replace(%op,,U)
    mysql_decho PREPROC> Packet: 11 $+ $replace(%op,,B,,R,,K,,O,$chr(0),0,$chr(32), ,|,P,u,)
  }
  if (%mysql_serverinfo) {
    if (%mysql_retain.row != $null) inc %mysql_retain.row
    var %data.sid = $bvar(&mysql.data,1)
    var %data.pos = 2
    while (%data.pos <= %bvl) {
      var %data.len = $bvar(&mysql.data,%data.pos)
      if (%data.len >= 254) inc %data.pos 3
      elseif (%data.len >= 251) {
        if (%data.len == 251) {
          var %l1 = $bvar(&mysql.data,$calc(%data.pos + 1))
          var %data.len = $calc(%l1 + 1)
          inc %data.pos 2
          mysql_decho SUBGETHEADER> L1: %l1 LEN: %data.len POS: %data.pos
        }
        elseif (%data.len == 252) {
          var %l1 = $bvar(&mysql.data,$calc(%data.pos + 1))
          var %l2 = $calc($bvar(&mysql.data,$calc(%data.pos + 2)) * 255)
          var %data.len = $calc(%l2 + %l1 + $bvar(&mysql.data,$calc(%data.pos + 2)))
          inc %data.pos 3
          mysql_decho SUBGETHEADER> L1: %l1 L2: %l2 LEN: %data.len POS: %data.pos
        }
        elseif (%data.len == 253) {
          var %l1 = $bvar(&mysql.data,$calc(%data.pos + 1))
          var %l2 = $calc($bvar(&mysql.data,$calc(%data.pos + 2)) * 255)
          var %l2 = $calc($bvar(&mysql.data,$calc(%data.pos + 3)) * 65025)
          var %data.len = $calc(%l3 + %l2 + %l1 + $bvar(&mysql.data,$calc(%data.pos + 3)))
          inc %data.pos 4
          mysql_decho SUBGETHEADER> L1: %l1 L2: %l2 L2: %l3 LEN: %data.len POS: %data.pos
        }
      }
      else inc %data.pos
      var %len = $calc(%data.pos + %data.len)
      var %out
      while (%data.pos < %len) {
        if ($bvar(&mysql.data,%data.pos) == 32) {
          inc %data.pos
          var %out = %out $chr($bvar(&mysql.data,%data.pos))
          inc %data.pos
        }
        elseif ($bvar(&mysql.data,%data.pos) == 0) {
          var %out = %out $+ 0
          inc %data.pos
        }
        else {
          var %out = %out $+ $chr($bvar(&mysql.data,%data.pos))
          inc %data.pos 1
        }
      }
      var %out = $replace(%out,,U)
      inc %mysql.subsid
      mysql_decho PROC> SequenceID: %data.sid SubSequenceID: %mysql.subsid DataPos: %data.pos DataLen: %data.len Data: $replace(%out,,B,,R,,K,,O,$chr(0),0,$chr(32), ,|,P,u,)
      if (%data.sid <= 2) && (%data.len == 255) {
        unset %mysql_retain.*
        var %mysql.cqn = %mysql_queryname
        var %mysql.cqcid = %mysql_querycid
        unset %mysql_query*
        var %mysql.usedata = %mysql_use_data
        unset %mysql_use_data
        set %mysql.error %out
        mysql_echo 4ERROR >> %out
        scid %mysql.cqcid
        if (%mysql.cqn) .signal mysql QUERY ERROR %mysql.cqn
        elseif (%mysql.usedata) .signal mysql ERROR %mysql.usedata
        else .signal mysql ERROR
        return
      }
      elseif (%data.sid == 2) && (%data.len == 0) && (%mysql.subsid == 3) && (%mysql_retain.gotheader == $null) {
        mysql_echo  $+ $color(info) MySQL>> Logged in.
        sockmark mysql OK
        mysql_use %mysql_client.database mysql_logged_in
      }
      elseif (%data.sid == 1) && (%data.len == 0) && (%mysql.subsid == 1) && (!%mysql_queryname) {
        mysql_vecho  $+ $color(info) MySQL>>  $+ $color(normal) $+ OK
        var %mysql.usedata = %mysql_use_data
        unset %mysql_use_data
        .signal mysql OK $iif(%mysql.usedata != $null,%mysql.usedata)
      }
      elseif (%data.sid == 1) && (%mysql.subsid == 2) && (%mysql_queryname) && (!%mysql_retain.row) {
        var %mysql.cqn = %mysql_queryname
        var %mysql.cqcid = %mysql_querycid
        unset %mysql_queryname
        mysql_vecho  $+ $color(info) MySQL>>  $+ $color(normal) $+ OK ( $+ %data.len rows affected)
        hadd -m mysql.result affected %data.len
        scid %mysql.cqcid
        .signal mysql QUERY %mysql.cqn %data.len
      }
      elseif (%data.sid >= 2) && (%mysql_retain.gotheader == $null) && (%mysql.subsid == 2) {
        if ($calc(%data.sid - 1) == 1) hmake mysql.columns 10
        mysql_decho Col( $+ $calc(%data.sid - 1) $+ ) = %out
        hadd mysql.columns col. $+ $calc(%data.sid - 1) %out
        hadd mysql.columns %out $calc(%data.sid - 1)
      }
      elseif (%data.len = 254) && (%mysql_retain.gotheader == $null) { 
        set %mysql_retain.gotheader $true
        set %mysql_retain.row 0
      }
      elseif (%data.len = 254) && (%mysql_retain.gotheader == $true) {
        unset %mysql_retain.*
        mysql_vecho  $+ $color(info) MySQL>>  $+ $color(normal) $+ OK ( $+ $mysql_colcount columns, $mysql_rowcount rows)
        var %mysql.cqn = %mysql_queryname
        var %mysql.cqcid = %mysql_querycid
        unset %mysql_query*
        scid %mysql.cqcid
        .signal mysql QUERY %mysql.cqn
      }
      elseif (%mysql_retain.gotheader == $true) {
        if ($hget(mysql.row. $+ %mysql_retain.row) == $null) hmake mysql.row. $+ %mysql_retain.row 10
        mysql_decho Row( $+ %mysql_retain.row $+ ) Col( $+ %mysql.subsid $+ ) = $replace(%out,|,|)
        hadd mysql.row. $+ %mysql_retain.row $hget(mysql.columns,col. $+ %mysql.subsid) %out
      }
    }
  }
  else {
    ;Parm1 -> Server version
    ;Parm2 -> 4 bytes for something...
    ;Parm3 -> 8 character password hash
    ;Parm4 -> Server language
    ;Parm5 -> 16 byte Server Capabilities String

    var %tb = $bvar(&mysql.data,0)
    var %cb = 1
    var %ci = 0
    var %dat
    while (%cb <= %tb) {
      var %cbv = $bvar(&mysql.data,%cb)
      if (%cbv == 255) && (%ci = 1) {
        mysql_echo 4ERROR >> $bvar(&mysql.data,$calc(%cb + 3),255).text
        set %mysql.error $bvar(&mysql.data,$calc(%cb + 3),255).text
        .signal mysql ERROR
        return
      }
      if (%cbv == 0) inc %ci
      if (%ci == 1) var %mysql.server_version = %mysql.server_version $+ $chr(%cbv)
      elseif (%ci == 2) { 
        inc %cb 1
        var %mysql.misc = $bvar(&mysql.data,%cb,4)
        inc %cb 4
        set %mysql_scramble $bvar(&mysql.data,%cb,8).text
        inc %cb 7
      }
      elseif (%ci == 3) var %mysql.server_language = %mysql.server_language $+ $chr(%cbv)
      elseif (%ci == 4) inc %cb 16
      inc %cb
    }
    var %mysql.protocol_version = $asc($left(%mysql.server_version,1))
    var %mysql.server_version = $right(%mysql.server_version,-1)
    if ($mysql_debug) {
      mysql_decho Protocol Version: %mysql.protocol_version
      mysql_decho Server Version: %mysql.server_version ( $+ $gettok($gettok(%mysql.server_version,1,46) $+ . $+ $remove($gettok(%mysql.server_version,2-,46),.),1,45) $+ )
      mysql_decho Misc: %mysql.con_id
      mysql_decho Password Hash: %mysql_scramble
      mysql_decho Server Language: $asc(%mysql.server_language)
    }
    if ($gettok($gettok(%mysql.server_version,1,46) $+ . $+ $remove($gettok(%mysql.server_version,2-,46),.),1,45) < 3.22) {
      mysql_echo 4ERROR >> The MySQL Server version is too old.  This script only supports version 3.22 or better. (Server Version: %mysql.server_version $+ )
      mysql_disconnect
      set %mysql.error The MySQL Server version is too old.  This script only supports version 3.22 or better. (Server Version: %mysql.server_version $+ )
      .signal mysql ERROR
      halt
    }
    if ($len(%mysql_scramble) < 8) {
      mysql_echo 4ERROR >> Did not receive a valid password hash. Unable to connect.
      mysql_disconnect
      set %mysql.error Did not receive a valid password hash. Unable to connect.
      .signal mysql ERROR
      halt
    }
    mysql.login %mysql_client.username $decode(%mysql_pass,m) %mysql_client.database
    unset %mysql_pass
  }
}

alias -l mysql.login {
  if ($3 != $null) mysql.send -decrbyte  000 $+ $1 $+ 0 $+ $iif($2 != '',$mysql.scramble($2,%mysql_scramble))
  else mysql.send -decrbyte 000 $+ $1 $+ 0
  set %mysql_serverinfo $true
}

;/*
;  This is the function that is responsible for outgoing communication with the server.
;  As with the incoming packets, we have to create a packet with a 3 byte header describing how long the packet is.
;  One difference here is that it can take a '-decbyte' flag that refrains from adding an extra $null at the end of the header.
;  [Note: The $null at the 4th byte of the header is the 'command'.  ASCII Char 2 is used to switch databases, and
;   $null is used for queries and just about everything else I've tried so far, which is why it is added by
;   default.]
;*/

alias -l mysql.send {
  hfree -w mysql.*
  bunset &mysql.header &mysql.data
  if ($1 == -decrbyte) {
    bset &mysql.data 1 $calc($len($replace($2-,0,0)) - 1) 0 0
    var %senddata = $2-
  }
  else {
    var %pl = $len($replace($1-,0,0))
    if (%pl <= 255) {
      var %pl3 = 0
      var %pl2 = 0
      var %pl1 = %pl
    }
    elseif (%pl <= 65025) {
      var %pl = $calc($len($replace($1-,0,0)) - $mysql.floor($calc(%pl / 255)))
      var %pl3 = 0
      var %pl2 = $mysql.floor($calc(%pl / 255))
      var %pl1 = $calc(%pl % 255)
    }
    else {
      mysql_echo 4ERROR >> Packet length exceeds 65025 bytes ( $+ %pl $+ )
      set %mysql.error Packet length exceeds 65025 bytes ( $+ %pl $+ )
      .signal mysql ERROR
      mysql_disconnect
      halt
    }
    mysql_decho SEND> Header: %pl1 %pl2 %pl3 PacketLength: %pl
    bset &mysql.data 1 %pl1 %pl2 %pl3
    var %senddata = 0 $+ $1-
  }
  var %cb = 4
  var %tsb = $len(%senddata)
  var %csb = 1
  while (%csb <= %tsb) {
    var %csbv = $asc($mid(%senddata,%csb,1))
    if (%csbv == 161) && ($mid(%senddata,%csb,3) == 0) {
      bset &mysql.data %cb 0
      inc %csb 3
    }
    else {
      bset &mysql.data %cb %csbv
      inc %csb
    }
    inc %cb
  }
  if ($mysql_debug == $true) {
    var %bvl = $bvar(&mysql.data,0)
    var %cb = 1
    while (%cb <= %bvl) {
      var %op2 = %op2 $bvar(&mysql.data,%cb)
      if ($bvar(&mysql.data,%cb) == 32) {
        inc %cb 1
        var %op = %op $chr($bvar(&mysql.data,%cb))
        inc %cb 1
      }
      elseif ($bvar(&mysql.data,%cb) == 0) {
        var %op = %op $+ u0u
        inc %cb 1
      }
      else {
        var %op = %op $+ $chr($bvar(&mysql.data,%cb))
        inc %cb 1
      }
      if ($len(%op) >= 150) {
        var %op = $replace(%op,,U)
        mysql_decho 13 $+ $replace(%op,,B,,R,,K,,O,$chr(0),0,$chr(32), ,|,P,u,)
        mysql_decho 13 $+ %op2
        unset %op
        unset %op2
      }
    }
    var %op = $replace(%op,,U)
    mysql_decho 13 $+ $replace(%op,,B,,R,,K,,O,$chr(0),0,$chr(32), ,|,P,u,)
    mysql_decho 13 $+ %op2
  }
  sockwrite mysql &mysql.data
}

;/*
;  Usage: $mysql.calcpl(&binvar)
;  Here is the function that calculates the packet length from the 3 byte header.
;*/

alias -l mysql.calcpl {
  if ($bvar($1,0) == 0) { return }
  var %b3 = 0
  var %b2 = $iif($bvar($1,2) > 0,$calc(($bvar($1,2) * 255) + 1),0)
  var %b1 = $bvar($1,1)
  var %hl = $calc(%b1 + %b2 + %b3)
  if ($bvar($1,2) > 1) inc %hl $calc($bvar($1,2) - 1)
  return %hl
}

;/*
;  Usage: $mysql.bitshift(int,N[,B])
;  I had to write this function to handle the bitshifting in the password scrambling functions below.
;*/
alias -l mysql.bitshift {
  ;$1 = base10 int to shift
  ;$2 = shift amount
  ;$3 = bitlen (defaults to 32 if not specified)
  var %bitlen = $iif($3,$3,32)
  var %in = $base($1,10,2)
  var %in = $iif($len(%in) < %bitlen,$str(0,$calc(%bitlen - $len(%in)))) $+ %in
  var %out = $right(%in,$calc($2 * -1)) $+ $str(0,$2)
  return $base(%out,2,10)
}

;/*
;  Here was the fun part in making this script. I didn't comment this because it would take up a lot more space =D
;  This is 'ported' from the source of MySQL 3.23 to handle the password authentification at login.
;  (Thanks to Mordred and his m4d C skillz for helping me port this =D)
;*/

alias -l mysql.hash_password {
  var %nr = 1345345333
  var %add = 7
  var %nr2 = 305419889
  var %tb = $len($1)
  var %cb = 1
  while (%cb <= %tb) {
    var %tmp = $asc($mid($1,%cb,1))
    if (%tmp != 32) && (%tmp != 9) {
      var %nr = $xor(%nr,$calc((($and(%nr,63) + %add) * %tmp) + $mysql.bitshift(%nr,8)))
      inc %nr2 $xor($mysql.bitshift(%nr2,8),%nr)
      if (%nr >= 4294967296) dec %nr 4294967296
      if (%nr2 >= 4294967296) dec %nr2 4294967296
      inc %add %tmp
    }
    inc %cb
  }
  var %result1 = $and(%nr,2147483647)
  var %result2 = $and(%nr2,2147483647)
  return %result1 %result2
}

alias -l mysql.rnd_init {
  set %mysql_rand.max_value 1073741823
  set %mysql_rand.seed1 $calc($1 % %mysql_rand.max_value)
  set %mysql_rand.seed2 $calc($2 % %mysql_rand.max_value)
}
alias -l mysql.rnd {
  set %mysql_rand.seed1 $calc((%mysql_rand.seed1 * 3 + %mysql_rand.seed2) % %mysql_rand.max_value)
  set %mysql_rand.seed2 $calc((%mysql_rand.seed1 + %mysql_rand.seed2 + 33) % %mysql_rand.max_value)
  return $calc(%mysql_rand.seed1 / %mysql_rand.max_value)
}

alias -l mysql.floor return $iif(. isin $1,$left($1,$calc($pos($1,.) - 1)),$1)

alias -l mysql.scramble {
  var %ph = $mysql.hash_password($1)
  var %sh = $mysql.hash_password($2)
  var %ph1 = $gettok(%ph,1,32)
  var %ph2 = $gettok(%ph,2,32)
  var %sh1 = $gettok(%sh,1,32)
  var %sh2 = $gettok(%sh,2,32)
  mysql.rnd_init $xor(%ph1,%sh1) $xor(%ph2,%sh2)
  var %tb = $len($2)
  var %cb = 1
  while (%cb <= %tb) {
    var %cbv = $calc($mysql.floor($calc($mysql.rnd * 31)) + 64 )
    var %preout = %preout %cbv
    inc %cb
  }
  var %cb = 1
  var %cbvx = $mysql.floor($calc($mysql.rnd * 31))
  while (%cb <= %tb) {
    var %cbv = $gettok(%preout,%cb,32)
    var %out = %out $+ $chr($xor(%cbv,%cbvx))
    inc %cb
  }
  return %out
}

;/* This is the version checking code, the script won't work on versions previous to 6.0 */

on *:load:mysql.mircversioncheck
on *:start:mysql.mircversioncheck
alias -l mysql.mircversioncheck {
  if ($version < 6) {
    echo -a 4MySQL> ERROR: This script requires mIRC 6.0 or higher to run, please upgrade before installing this script.
    echo -a 4MySQL> Unloading $script
    unload -rs $script
  }
}

menu status,channel,query,@MySQL {
  -
  MySQL
  .Launch GUI:mysql_gui
  .Configure
  ..Edit Settings:mysql_config
  ..-
  ..$iif($mysql_htmlout,$style(1)) HTML Output:{
    writeini mysql.conf general htmlout $iif($mysql_htmlout,$false,$true)
    if ($dialog(mysql_gui)) did $iif($mysql_htmlout,-c,-u) mysql_gui 16
  }
  ..$iif($mysql_cwindow,$style(1)) @MySQL Output:{
    writeini mysql.conf general cwindow $iif($mysql_cwindow,$false,$true)
    if ($dialog(mysql_gui)) did $iif($mysql_cwindow,-c,-u) mysql_gui 22
  }
  ..$iif($mysql_verbose,$style(1)) Verbose Output:{
    writeini mysql.conf general verbose $iif($mysql_verbose,$false,$true)
    if ($dialog(mysql_gui)) did $iif($mysql_verbose,-c,-u) mysql_gui 28
  }
  ..$iif($mysql_debug,$style(1)) Debug Output:{
    writeini mysql.conf general debug $iif($mysql_debug,$false,$true)
    if ($dialog(mysql_gui)) did $iif($mysql_debug,-c,-u) mysql_gui 29
  }
  .-
  .Connect:mysql_connect
  .Disconnect:mysql_disconnect
  .-
  .Query:mysql_query query $$input(Enter an SQL query,5,MySQL Query)
  .List Databases:mysql_query query show databases
  .List Tables:mysql_query query show tables
  .Get Table Info:mysql_query query describe $$input(Enter a table to describe,5,MySQL Query)
  -
}

;/*
;  This handles the HTML output and some of the GUI output as well.
;*/

on *:signal:mysql:{
  mysql_decho SIGNAL: $1-
  if ($mysql_htmlout) {
    if (($1 == query) && ($2 != error) && ($mysql_rowcount)) {
      var %outfile = $mysql_htmlout.file
      if ($isfile(%outfile)) .remove %outfile
      write %outfile <html><head><title>MySQL Query Results</title>
      write %outfile <style>
      write %outfile table $chr(123)
      write %outfile font-family : Arial, Helvetica, sans-serif;
      write %outfile font-size : 8pt;
      write %outfile background-color : 999999;
      write %outfile border : thin outset ThreedHighlight;
      write %outfile $chr(125)
      write %outfile td $chr(123)
      write %outfile font-family : Arial, Helvetica, sans-serif;
      write %outfile font-size : 8pt;
      write %outfile background-color : CCCCCC;
      write %outfile $chr(125)
      write %outfile body $chr(123)
      write %outfile font-family : Arial, Helvetica, sans-serif;
      write %outfile font-size : 8pt;
      write %outfile padding: 10px;
      write %outfile margin: 10px;
      write %outfile $chr(125)
      write %outfile </style>
      write %outfile </head>
      write %outfile <body bgcolor="FFFFFF" text="000000">
      write %outfile Query Name: $2 $+ <br>Columns: $mysql_colcount $+ <br>Rows: $mysql_rowcount $+ <br><br>
      if ($mysql_rowcount == 0) write %outfile No results returned.
      else {
        write %outfile <table cellspacing="1" cellpadding="4">
        write %outfile <tr>
        var %tc = $mysql_colcount
        var %cc = 1
        while (%cc <= %tc) {
          write %outfile <td><b> $+ $mysql_getcol(%cc) $+ </b></td>
          inc %cc
        }
        write %outfile </tr>
        var %tr = $mysql_rowcount
        var %cr = 1
        while (%cr <= %tr) {
          write %outfile <tr>
          var %tc = $mysql_colcount
          var %cc = 1
          while (%cc <= %tc) {
            write %outfile <td> $+ $replace($mysql_getfield(%cc,%cr),<,&lt;,>,&gt;) $+ </td>
            inc %cc
          }
          write %outfile </tr>
          inc %cr
        }
        write %outfile </table>
        write %outfile <br>Generated on $asctime
        write %outfile </body></html>
      }
      if ($mysql_htmlout.run) run %outfile
    }
  }
  elseif ($dialog(mysql_gui)) {
    if ($1-2 == query gui_query) {
      ;did -a mysql_gui 20 $crlf $+ Query Results: $+ $crlf $+ =========================
      if ($mysql_rowcount == 0) did -a mysql_gui 20 $crlf $+ No results returned.
      else {
        var %tc = $mysql_colcount
        var %cc = 1
        did -a mysql_gui 20 $crlf
        while (%cc <= %tc) {
          did -a mysql_gui 20 $mysql_getcol(%cc) $+ $iif(%cc < %tc,$chr(9))
          inc %cc
        }
        did -a mysql_gui 20 $crlf $+ =========================
        var %tr = $mysql_rowcount
        var %cr = 1
        while (%cr <= %tr) {
          did -a mysql_gui 20 $crlf
          var %tc = $mysql_colcount
          var %cc = 1
          while (%cc <= %tc) {
            did -a mysql_gui 20 $mysql_getfield(%cc,%cr) $+ $iif(%cc < %tc,$chr(9))
            inc %cc
          }
          inc %cr
        }
        did -a mysql_gui 20 $crlf $+ =========================
      }
    }
  }
}

;## The following is the Graphical User Interface (GUI)
;## I didn't feel the need to comment this part =)

alias mysql mysql_gui
alias mysql_gui {
  if (!$dialog(mysql_gui)) dialog -md mysql_gui mysql_interface
  else dialog -v mysql_gui
}

dialog mysql_interface {
  title "MySQL Interface"
  size -1 -1 284 172
  option dbu
  box " Configuration ", 1, 111 3 169 58
  text "Server IP/Host", 7, 117 13 59 10
  text "Port", 8, 183 13 21 10
  edit "", 5, 115 22 65 12, limit 50
  edit "", 6, 181 22 25 12, limit 5
  text "Default Database", 9, 117 35 50 10
  edit "", 10, 115 44 91 12, limit 50
  box " Query History ", 11, 4 3 103 58
  list 12, 9 12 93 33, size vsbar
  button "Use", 13, 10 47 43 10, flat
  button "Delete", 14, 57 47 43 10, flat
  box "Query", 18, 4 63 276 104
  edit "", 19, 9 71 224 12
  edit "", 20, 9 87 266 74, read multi return hsbar vsbar
  button "Execute", 21, 237 71 37 12, default flat
  text "Username", 2, 210 13 63 10
  edit "", 3, 209 22 65 12, limit 50
  text "Password", 4, 210 35 63 10
  edit "", 26, 209 44 65 12, pass limit 50
  menu "File", 15
  item "Clear Results", 37, 15
  item "Clear Query History", 39, 15
  item break, 38, 15
  item "Close", 17, 15, ok
  menu "Settings", 27
  item "Save Settings", 30, 27
  item break, 31, 27
  item "HTML Output", 16, 27
  item "@MySQL Output", 22, 27
  item "Verbose", 28, 27
  item "Debug", 29, 27
  menu "Server", 23
  item "Connect", 24, 23
  item "Disconnect", 25, 23
  item break, 33, 23
  item "Show Status", 34, 23
  item "Show Databases", 35, 23
  item "Show Tables", 36, 23
}

on *:dialog:mysql_gui:init:0:{
  var %host = $readini(mysql.conf,general,host)
  var %port = $readini(mysql.conf,general,port)
  var %database = $readini(mysql.conf,general,database)
  var %htmlout = $readini(mysql.conf,general,htmlout)
  var %cwindow = $readini(mysql.conf,general,cwindow)
  var %verbose = $readini(mysql.conf,general,verbose)
  var %debug = $readini(mysql.conf,general,debug)
  var %username = $readini(mysql.conf,general,username)
  var %password = $readini(mysql.conf,general,password)
  did $iif(%htmlout,-c,-u) mysql_gui 16
  did $iif(%cwindow,-c,-u) mysql_gui 22
  did $iif(%verbose,-c,-u) mysql_gui 28
  did $iif(%debug,-c,-u) mysql_gui 29
  did -o mysql_gui 5 1 %host
  did -o mysql_gui 6 1 %port
  did -o mysql_gui 10 1 %database
  did -o mysql_gui 3 1 %username
  did -o mysql_gui 26 1 $decode(%password,m)
  did -f mysql_gui 19
}

on *:dialog:mysql_gui:menu:37:did -r mysql_gui 20
on *:dialog:mysql_gui:menu:39:did -r mysql_gui 12

on *:dialog:mysql_gui:menu:30:{
  var %host = $iif($did(mysql_gui,5).text,$did(mysql_gui,5).text,localhost)
  var %port = $iif($did(mysql_gui,6).text,$did(mysql_gui,6).text,3306)
  var %database = $iif($did(mysql_gui,10).text,$did(mysql_gui,10).text,mysql)
  var %username = $iif($did(mysql_gui,3).text,$did(mysql_gui,3).text,anonymous)
  var %password = $iif($did(mysql_gui,26).text,$encode($did(mysql_gui,26).text,m))
  writeini mysql.conf general host %host
  writeini mysql.conf general port %port
  writeini mysql.conf general username %username
  if (%password != $null) writeini mysql.conf general password $encode(%password,m)
  else {
    remini mysql.conf general password
    var %pchk = $$input(Ask for password on connect?,y,MySQL Configuration)
    if (%pchk) writeini mysql.conf general pchk $true
    else writeini mysql.conf general pchk $false
  }
  writeini mysql.conf general database %database
  dialog -v mysql_gui
}
on *:dialog:mysql_gui:menu:16:{
  writeini mysql.conf general htmlout $iif($mysql_htmlout,$false,$true)
  did $iif($mysql_htmlout,-c,-u) mysql_gui 16
}
on *:dialog:mysql_gui:menu:22:{
  writeini mysql.conf general cwindow $iif($mysql_cwindow,$false,$true)
  did $iif($mysql_cwindow,-c,-u) mysql_gui 22
}
on *:dialog:mysql_gui:menu:28:{
  writeini mysql.conf general verbose $iif($mysql_verbose,$false,$true)
  did $iif($mysql_verbose,-c,-u) mysql_gui 28
}
on *:dialog:mysql_gui:menu:29:{
  writeini mysql.conf general debug $iif($mysql_debug,$false,$true)
  did $iif($mysql_debug,-c,-u) mysql_gui 29
}

on *:dialog:mysql_gui:menu:24:{
  var %host = $iif($did(mysql_gui,5).text,$did(mysql_gui,5).text,localhost)
  var %port = $iif($did(mysql_gui,6).text,$did(mysql_gui,6).text,3306)
  mysql_connect %host %port $did(mysql_gui,10).text $did(mysql_gui,3).text $did(mysql_gui,26).text 
}
on *:dialog:mysql_gui:menu:25:mysql_disconnect
on *:dialog:mysql_gui:menu:34:mysql_query gui_query Show Status
on *:dialog:mysql_gui:menu:35:mysql_query gui_query Show Databases
on *:dialog:mysql_gui:menu:36:mysql_query gui_query Show Tables

on *:dialog:mysql_gui:dclick:12:did -o mysql_gui 19 1 $did(mysql_gui,12).seltext
on *:dialog:mysql_gui:sclick:13:did -o mysql_gui 19 1 $did(mysql_gui,12).seltext
on *:dialog:mysql_gui:sclick:14:did -d mysql_gui 12 $did(mysql_gui,12).sel

on *:dialog:mysql_gui:sclick:21:{
  if ($did(mysql_gui,19).text) {
    if ($gettok($did(mysql_gui,19).text,1,32) == use) mysql_use $gettok($did(mysql_gui,19).text,2-,32)
    else mysql_query gui_query $did(mysql_gui,19).text
    did -a mysql_gui 12 $did(mysql_gui,19).text
    did -c mysql_gui 12 $did(mysql_gui,12).lines
    did -r mysql_gui 19
  }
}
